package com.javacorporate.forum.dbobj;

import com.javacorporate.db.*;
import com.javacorporate.dbobj.*;
import java.util.*;
import com.javacorporate.common.util.LogException;
import com.javacorporate.common.util.LogHandler;
import com.javacorporate.common.util.EventHandler;

import com.javacorporate.common.dbobj.*;


/**
* What Forum's are particular users subscribed to
*/
public class ForumSubscribe extends SecuredDBObject {
	private String thisClass = new String(this.getClass().getName() + ".");

	public ForumSubscribe() throws DBException {
		super();
	}
	public ForumSubscribe(String theUser) throws DBException {
		super(theUser);
	}
/**
 * Insert the method's description here.
 * Creation date: (5/4/00 3:49:53 PM)
 */
public void add() throws DBException {
	String myName = new String(thisClass + "add()");
	super.add();

	ForumGroup myGroup = new ForumGroup();
	myGroup.setField("GroupId", getField("GroupId"));
	myGroup.retrieve();

	ForumSubscribe fs = new ForumSubscribe();
	fs.setField("GroupId", getField("GroupId"));
	fs.setField("Admin", "Y");
	
	ForumSubscribe oneSubscribe = null;
	
	User oneAdmin = null;
	String msg = null;
	
	for (Enumeration e = fs.searchAndRetrieve().elements(); e.hasMoreElements(); ) {
		oneSubscribe = (ForumSubscribe) e.nextElement();
		oneAdmin = new User();
		oneAdmin.setField("UserName", oneSubscribe.getField("UserName"));
		if (oneAdmin.find()) {
			msg = new String("User " + getField("UserName") + " has just subscribed to eForum group '"
					+ myGroup.getField("GroupDescription") + "'. You are listed as an Administrator for this group."); 
			try {
				EventHandler.notify(oneAdmin.getField("UserName"), "New Subscription to Group " 
					+ myGroup.getField("GroupDescription"), msg);
			} catch (LogException le) {
				LogHandler.tryLog(myName, "Unable to send message to " + oneAdmin.getField("UserName") + ":" 
					+ le.getMessage());
			}
		}
		
	}
	
}
	public DBObject getThisDBObj() throws DBException {
		return new ForumSubscribe();
	}
	protected synchronized void setupFields() throws DBException {
		setTargetTable("FORUMSUBSCRIBE");

		setDescription("Forum Subscriptions");

		addField("GroupId",	"int", 0, false, "Group ID");
		addField("UserName", "char", 30, false, "User Name");
		addField("Notices", "char", 1, true, "Receive Notices");
		addField("EMail", "char", 1, true, "Messages via EMail");
		addField("Summaries", "char", 1, true, "Daily Summaries");
		addField("Admin", "char", 1, true, "Administrator?");
		addField("Moderator", "char", 1, true, "Moderator?");

		addKey("GroupId");
		addKey("UserName");
	}
}
