package com.javacorporate.forum.dbobj;

/*
 * ForumThread.java
 *
 * Copyright 1999 Javacorporate Ltd.
 */

import com.javacorporate.dbobj.*;
import com.javacorporate.db.*;
import com.javacorporate.common.dbobj.NextNumber;
import com.javacorporate.common.util.DateTime;
import java.util.Hashtable;
import java.util.Calendar;
import java.util.Enumeration;

/**
 * ForumThread
 *
 * @version		$Revision: 1.2 $  $Date: 2000/04/07 18:35:19 $
 * @author		Michael Nash
 */
public class ForumThread extends SecuredDBObject {
	private Hashtable values = null;

	/**
	 * @see com.javacorporate.dbobj.SecuredDBObject
	 */
	public ForumThread() throws DBException {
		super();
	} /* ForumThread() */
	/**
	 * @see com.javacorporate.dbobj.SecuredDBObject
	 */
	public ForumThread(String theUser) throws DBException {

		super(theUser);
	} /* ForumThread(String) */
	/**
	 * Extends the usual add method to fetch a next number field
	 * and set the created date/time
	 *
	 * @throws	DBException If the next number cannot be determined or
	 * 			the add fails
	 */
	public void add() throws DBException {

		setField("LastPosting", DateTime.getDateTimeForDB());
		setField("LastPostingBy", getUser());
		
		NextNumber myNext = new NextNumber("SYSTEM");
		long myIdNum = myNext.getNextTentative("FTHREAD");
		setField("ThreadId", new String().valueOf(myIdNum));

		super.add();
		myNext.getNextConfirm("FTHREAD");
	} /* add() */
	/**
	 * @see com.javacorporate.dbobj.SecuredDBObject#getThisDBObj()	 
	 *
	 * @returns	DBObject
	 * @throws	DBException
	 */
	public DBObject getThisDBObj() throws DBException {
		return new ForumThread();
	} /* getThisDBObj() */
	/**
	 * @see com.javacorporate.dbobj.SecuredDBObject
	 */
	protected synchronized void setupFields() throws DBException {
		setTargetTable("FORUMTHREAD");

		setDescription("Forum Threads");

		addField("ThreadId", "int", 0, false, "Thread Id");
		addField("GroupId", "int", 0, false, "Group Id");
		addField("Subject", "varchar", 80, false, "Subject");
		addField("LastPosting", "datetime", 0, false, "Last Posting");
		addField("LastPostingBy", "char", 30, false, "Last Posting By");

		addKey("ThreadId");
		setReadOnly("ThreadId");
	} /* setupFields() */
} /* ForumThread */
